<?php

namespace AppBundle\Repository;

/**
 * GroupRepository
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 */

class GroupRepository extends \Doctrine\ORM\EntityRepository
{
    public function queryAll($status = 1, $parent = null, $weight = -1)
    {
        $qb = $this->createQueryBuilder('d')
            ->leftJoin('d.parent', 'p1')
        ->leftJoin('d.parent2', 'p2');
        if ($status) {
            $qb
            ->where('d.active = :status')
            ->setParameter("status", 1);
        }
        if($parent)
            $qb->andWhere('p1.id = :parent OR p2.id = :parent')
                ->setParameter("parent", $parent->getId());
        if($weight > -1) {
            $qb
                ->andWhere('d.weight = :weight')
                ->setParameter("weight", $weight);
        }
        $qb->orderBy('d.weight', 'ASC');

        return $qb;
    }

    public function queryInfoGroups()
    {
        $qb = $this->createQueryBuilder('d');
        $qb->andWhere('d.info = :info')
            ->setParameter("info", true);
        $qb->orderBy('d.weight', 'ASC');

        return $qb;
    }

    public function queryProposalGroups()
    {
        $qb = $this->createQueryBuilder('d');
        $qb->andWhere('d.proposal = :proposal')
            ->setParameter("proposal", true);
        $qb->orderBy('d.weight', 'ASC');

        return $qb;
    }

    public function queryTaskGroups()
    {
        $qb = $this->createQueryBuilder('d');
        $qb->andWhere('d.task = :task')
            ->setParameter("task", true);
        $qb->orderBy('d.weight', 'ASC');

        return $qb;
    }

    public function queryGroupByWeight($weight)
    {
        $qb = $this->queryAll(1, null, $weight);
        $qb->setMaxResults(1);
        $res = $qb->getQuery()->getResult();
        if(count($res) > 0)
            return $res['0'];
        return null;
    }

    public function queryMainGroups($weight)
    {
        $qb = $this->createQueryBuilder('d')
            ->leftJoin('d.parent', 'm')
            ->where('d.active = :status')
            ->setParameter("status", 1);
        $qb->andWhere('d.parent IS NULL OR (d.parent IS NOT NULL and m.weight = :weight)')
            ->setParameter("weight", $weight);

        $qb->orderBy('d.weight', 'ASC');

        return $qb;
    }
}